/*
 * GenericFunction.java
 *
 * Copyright (C) 2003-2005 Peter Graves
 * $Id: GenericFunction.java,v 1.25 2005/08/16 18:19:48 piso Exp $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package org.armedbear.lisp;

public abstract class GenericFunction extends StandardObject
{
    protected GenericFunction(LispClass cls, int length)
    {
        super(cls, length);
    }

    public LispObject typep(LispObject type) throws ConditionThrowable
    {
        if (type == Symbol.GENERIC_FUNCTION)
            return T;
        if (type == StandardClass.GENERIC_FUNCTION)
            return T;
        if (type == Symbol.FUNCTION)
            return T;
        if (type == BuiltInClass.FUNCTION)
            return T;
        return super.typep(type);
    }
}
