/*
 * lognot.java
 *
 * Copyright (C) 2003-2005 Peter Graves
 * $Id: lognot.java,v 1.7 2005/08/15 23:26:48 piso Exp $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package org.armedbear.lisp;

import java.math.BigInteger;

// ### lognot
public final class lognot extends Primitive
{
    private lognot(String name, String arglist)
    {
        super(name, arglist);
    }

    public LispObject execute(LispObject arg) throws ConditionThrowable
    {
        return arg.LOGNOT();
    }

    private static final Primitive LOGNOT = new lognot("lognot", "integer");
}
